/*
******************************************************************************

   Edemo implementation for "my" target - everything in a single file.

   Authors:	1999-2000 Marcus Sundberg	[marcus@ggi-project.org]
  
   This code is placed in the public domain and may be used freely for any
   purpose.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include <stdio.h>
#include <ggi/internal/edemo.h>


static int EDEMO_my_function1(ggi_visual_t vis, int arg1)
{
	printf("LibEDEMO: EDEMO_my_function1(%p, %d) called\n", vis, arg1);

	return 0;
}	/* EDEMO_my_function1 */


int EDEMO_my_function2(ggi_visual_t vis, int arg1, int arg2)
{
	printf("LibEDEMO: EDEMO_my_function2(%p, %d, %d) called\n",
	       vis, arg1, arg2);

	return 0;
}	/* EDEMO_my_function2 */


static int GGIopen(ggi_visual *vis, struct ggi_dlhandle *dlh,
		   const char *args, void *argptr, uint32 *dlret)
{
	printf("LibEDEMO: GGIopen(%p, %p, %s, %p, %p) called for my_edemo sublib\n",
	       vis, dlh, args ? args : "(NULL)", argptr, dlret);

	LIBGGI_EDEMOEXT(vis)->function1 = EDEMO_my_function1;
	LIBGGI_EDEMOEXT(vis)->function2 = EDEMO_my_function2;

	*dlret = (GGI_DL_EXTENSION | GGI_DL_OPDISPLAY);
	return 0;
}	/* GGIopen */


static int GGIclose(ggi_visual *vis, struct ggi_dlhandle *dlh)
{
	printf("LibEDEMO: GGIclose(%p, %p) called for my_edemo sublib\n",
	       vis, dlh);

	return 0;
}	/* GGIclose */


int EDEMOdl_my_edemo(int func, void **funcptr)
{
	switch (func) {
	case GGIFUNC_open:
		*funcptr = GGIopen;
		return 0;
	case GGIFUNC_exit:
		*funcptr = NULL;
		return 0;
	case GGIFUNC_close:
		*funcptr = GGIclose;
		return 0;
	default:
		*funcptr = NULL;
	}	/* switch */

	return GGI_ENOTFOUND;
}	/* EDEMOdl_my_edemo */


/* This should be included by exactly _one_ file in each sublib. */
#include <ggi/internal/ggidlinit.h>
